Rysunek Roboczy: Krzywa złożona

From FreeCAD Documentation
Revision as of 13:40, 22 November 2023 by Kaktus (talk | contribs) (Created page with "Skróty klawiaturowe jedno znakowe dostępne w panelu zadań można zmienić. Zobacz stronę Preferencji. Skróty wymienione tutaj są skrótami domyślnymi.")

Draft: Krzywa złożona

Lokalizacja w menu
Kreślenie → Krzywa złożona
Środowisko pracy
Rysunek Roboczy, Architektura
Domyślny skrót
B S
Wprowadzono w wersji
0.7
Zobacz także
Polilinia, Sześcienna krzywa Béziera, Krzywa Béziera

Opis

Polecenie Krzywa złożona tworzy krzywą B-spline na podstawie kilku punktów.

Polecenie Krzywa złożona określa punkty exact points, przez które będzie przechodzić krzywa. Polecenia Krzywa złożona i Sześcienna krzywa Beziera używają z kolei punktów kontrolnych do określenia położenia i krzywizny odcinka krzywej.

Odcinek krzywej zdefiniowany przez wiele punktów.

Użycie

Zapoznaj się również z informacjami na stronie: Tacka narzędziowa, Przyciąganie oraz Wiązania.

  1. Polecenie można wywołać na kilka sposobów:
    • Naciśnij przycisk Krzywa złożona.
    • Wybierz opcję Drafting → Krzywa złożona z menu.
    • Użyj skrótu klawiaturowego: B, a następnie S.
  2. Otworzy się panel zadań Krzywa złożona. Więcej informacji znajduje się w sekcji Opcje.
  3. Wybierz pierwszy punkt w oknie widoku 3D lub wpisz współrzędne i naciśnij przycisk Wprowadź punkt
  4. Wybierz dodatkowe punkty w oknie widoku 3D lub wpisz współrzędne i naciśnij przycisk Wprowadź punkt.
  5. Naciśnij Esc lub przycisk Zamknij, aby zakończyć polecenie.

Opcje

Skróty klawiaturowe jedno znakowe dostępne w panelu zadań można zmienić. Zobacz stronę Preferencji. Skróty wymienione tutaj są skrótami domyślnymi.

  • To manually enter coordinates enter the X, Y and Z component, and press Enter after each. Or you can press the Enter point button when you have the desired values. It is advisable to move the pointer out of the 3D view before entering coordinates.
  • Press R or click the Relative checkbox to toggle relative mode. If relative mode is on, coordinates are relative to the last point, if available, else they are relative to the coordinate system origin.
  • Press G or click the Global checkbox to toggle global mode. If global mode is on, coordinates are relative to the global coordinate system, else they are relative to the working plane coordinate system. introduced in version 0.20
  • Press L or click the Filled checkbox to toggle filled mode. If filled mode is on, the created spline will have DANEMake Face set to true and will have a filled face, provided it is closed and does not self-intersect. Note that a self-intersecting spline with a face will not display properly, for such a spline DANEMake Face must be set to false.
  • Press T or click the Continue checkbox to toggle continue mode. If continue mode is on, the command will restart after using Finish or Close, or after creating a closed spline by snapping to the first point of the spline, allowing you to continue creating splines.
  • Press / or the Undo button to undo the last point.
  • Press A or the Finish button to finish the command and leave the spline open.
  • Press O or the Close button to finish the command and close the spline. A closed spline can also be created by snapping to the first point of the spline.
  • Press W or the Wipe button to delete the curve segments already placed, but keep working from the last point.
  • Press U or the Set WP button to adjust the current working plane in the orientation defined by the last and the previous point.
  • Press S to switch Draft snapping on or off.
  • Press Esc or the Close button to finish the command.

Notes

Preferences

See also: Preferences Editor and Draft Preferences.

  • To change the number of decimals used for the input of coordinates: Edit → Preferences... → General → Units → Units settings → Number of decimals.
  • To change the initial value of filled mode: Edit → Preferences... → Draft → General settings → Draft tools options → Fill objects with faces whenever possible. Changing the filled mode in a task panel will override this preference for the current FreeCAD session.

Properties

See also: Property editor.

A Draft BSpline object is derived from a Part Part2DObject and inherits all its properties. It also has the following additional properties:

Data

Draft

  • DANEArea (Area): (read-only) specifies the area of the face of the spline. The value will be 0.0 if DANEMake Face if false or the face cannot be created.
  • DANEClosed (Bool): specifies if the spline is closed or not. If the spline is initially open this value is false, setting it to true will draw a curve segment to close the spline. If the spline is initially closed this value is true, setting it to false will remove the last curve segment and make the spline open.
  • DANEMake Face (Bool): specifies if the spline makes a face or not. If it is true a face is created, otherwise only the perimeter is considered part of the object. This property only works if DANEClosed is true and if the spline does not self-intersect.
  • DANEParameterization (Float): affects the shape of the spline.
  • DANEPoints (VectorList): specifies the points of the spline in its local coordinate system.

View

Draft

  • WIDOKArrow Size (Length): specifies the size of the symbol displayed at the end of the spline.
  • WIDOKArrow Type (Enumeration): specifies the type of symbol displayed at the end of the spline, which can be Dot, Circle, Arrow, Tick or Tick-2.
  • WIDOKEnd Arrow (Bool): specifies whether to show a symbol at the end of the spline, so it can be used as an annotation line.
  • WIDOKPattern (Enumeration): specifies the Draft Pattern with which to fill the face of the closed spline. This property only works if DANEMake Face is true and if WIDOKDisplay Mode is Flat Lines.
  • WIDOKPattern Size (Float): specifies the size of the Draft Pattern.

Scripting

See also: Autogenerated API documentation and FreeCAD Scripting Basics.

To create a Draft BSpline use the make_bspline method (introduced in version 0.19) of the Draft module. This method replaces the deprecated makeBSpline method.

bspline = make_bspline(pointslist, closed=False, placement=None, face=None, support=None)
bspline = make_bspline(Part.Wire, closed=False, placement=None, face=None, support=None)
  • Creates a bspline object from the given list of points, pointslist.
    • Each point in the list is defined by its FreeCAD.Vector, with units in millimeters.
    • Alternatively, the input can be a Part.Wire, from which points are extracted.
  • If closed is True, or if the first and last points are identical, the spline is closed.
  • If placement is None the spline is created at the origin.
  • If face is True, and the spline is closed, the spline will make a face, that is, it will appear filled.

Example:

import FreeCAD as App
import Draft

doc = App.newDocument()

p1 = App.Vector(0, 0, 0)
p2 = App.Vector(1000, 1000, 0)
p3 = App.Vector(2000, 0, 0)

spline1 = Draft.make_bspline([p1, p2, p3], closed=False)
spline2 = Draft.make_bspline([p1, 2*p3, 1.3*p2], closed=False)
spline3 = Draft.make_bspline([1.3*p3, p1, -1.7*p2], closed=False)

doc.recompute()